--- net/minecraft/src/PlayerControllerMP.java
+++ net/minecraft/src/PlayerControllerMP.java
@@ -3,155 +3,421 @@
 import net.minecraft.client.Minecraft;
 
 public class PlayerControllerMP extends PlayerController {
-	private int currentBlockX = -1;
-	private int currentBlockY = -1;
-	private int currentBlockZ = -1;
-	private float curBlockDamageMP = 0.0F;
-	private float prevBlockDamageMP = 0.0F;
-	private float stepSoundTickCounter = 0.0F;
-	private int blockHitDelay = 0;
-	private boolean isHittingBlock = false;
+//	private int currentBlockX = -1;
+//	private int currentBlockY = -1;
+//	private int currentBlockZ = -1;
+//	private float curBlockDamageMP = 0.0F;
+//	private float prevBlockDamageMP = 0.0F;
+//	private float stepSoundTickCounter = 0.0F;
+//	private int blockHitDelay = 0;
+//	private boolean isHittingBlock = false;
+//	private int currentPlayerItem = 0;
 	private NetClientHandler netClientHandler;
-	private int currentPlayerItem = 0;
 
 	public PlayerControllerMP(Minecraft var1, NetClientHandler var2) {
 		super(var1);
 		this.netClientHandler = var2;
 	}
 
-	public void flipPlayer(EntityPlayer var1) {
-		var1.rotationYaw = -180.0F;
-	}
-
-	public boolean sendBlockRemoved(int var1, int var2, int var3, int var4) {
-		this.netClientHandler.addToSendQueue(new Packet14BlockDig(3, var1, var2, var3, var4));
-		int var5 = this.mc.theWorld.getBlockId(var1, var2, var3);
-		int var6 = this.mc.theWorld.getBlockMetadata(var1, var2, var3);
-		boolean var7 = super.sendBlockRemoved(var1, var2, var3, var4);
-		ItemStack var8 = this.mc.thePlayer.getCurrentEquippedItem();
-		if(var8 != null) {
-			var8.onDestroyBlock(var5, var1, var2, var3);
-			if(var8.stackSize == 0) {
-				var8.onItemDestroyedByUse(this.mc.thePlayer);
-				this.mc.thePlayer.destroyCurrentEquippedItem();
-			}
-		}
-
-		if(var7 && this.mc.thePlayer.canHarvestBlock(Block.blocksList[var5])) {
-			Block.blocksList[var5].dropBlockAsItem(this.mc.theWorld, var1, var2, var3, var6);
-		}
-
-		return var7;
-	}
-
-	public void clickBlock(int var1, int var2, int var3, int var4) {
-		this.isHittingBlock = true;
-		this.netClientHandler.addToSendQueue(new Packet14BlockDig(0, var1, var2, var3, var4));
-		int var5 = this.mc.theWorld.getBlockId(var1, var2, var3);
-		if(var5 > 0 && this.curBlockDamageMP == 0.0F) {
-			Block.blocksList[var5].onBlockClicked(this.mc.theWorld, var1, var2, var3, this.mc.thePlayer);
-		}
-
-		if(var5 > 0 && Block.blocksList[var5].blockStrength(this.mc.thePlayer) >= 1.0F) {
-			this.sendBlockRemoved(var1, var2, var3, var4);
-		}
-
-	}
-
-	public void resetBlockRemoving() {
-		if(this.isHittingBlock) {
-			this.isHittingBlock = false;
-			this.netClientHandler.addToSendQueue(new Packet14BlockDig(2, 0, 0, 0, 0));
-			this.curBlockDamageMP = 0.0F;
-			this.blockHitDelay = 0;
-		}
-	}
-
-	public void sendBlockRemoving(int var1, int var2, int var3, int var4) {
-		this.isHittingBlock = true;
-		this.syncCurrentPlayItem();
-		this.netClientHandler.addToSendQueue(new Packet14BlockDig(1, var1, var2, var3, var4));
-		if(this.blockHitDelay > 0) {
-			--this.blockHitDelay;
-		} else {
-			if(var1 == this.currentBlockX && var2 == this.currentBlockY && var3 == this.currentBlockZ) {
-				int var5 = this.mc.theWorld.getBlockId(var1, var2, var3);
-				if(var5 == 0) {
-					return;
-				}
-
-				Block var6 = Block.blocksList[var5];
-				this.curBlockDamageMP += var6.blockStrength(this.mc.thePlayer);
-				if(this.stepSoundTickCounter % 4.0F == 0.0F && var6 != null) {
-					this.mc.sndManager.playSound(var6.stepSound.getStepSound(), (float)var1 + 0.5F, (float)var2 + 0.5F, (float)var3 + 0.5F, (var6.stepSound.getVolume() + 1.0F) / 8.0F, var6.stepSound.getPitch() * 0.5F);
-				}
-
-				++this.stepSoundTickCounter;
-				if(this.curBlockDamageMP >= 1.0F) {
-					this.sendBlockRemoved(var1, var2, var3, var4);
-					this.curBlockDamageMP = 0.0F;
-					this.prevBlockDamageMP = 0.0F;
-					this.stepSoundTickCounter = 0.0F;
-					this.blockHitDelay = 5;
-				}
-			} else {
-				this.curBlockDamageMP = 0.0F;
-				this.prevBlockDamageMP = 0.0F;
-				this.stepSoundTickCounter = 0.0F;
-				this.currentBlockX = var1;
-				this.currentBlockY = var2;
-				this.currentBlockZ = var3;
-			}
-
-		}
-	}
-
-	public void setPartialTime(float var1) {
-		if(this.curBlockDamageMP <= 0.0F) {
-			this.mc.ingameGUI.damageGuiPartialTime = 0.0F;
-			this.mc.renderGlobal.damagePartialTime = 0.0F;
-		} else {
-			float var2 = this.prevBlockDamageMP + (this.curBlockDamageMP - this.prevBlockDamageMP) * var1;
-			this.mc.ingameGUI.damageGuiPartialTime = var2;
-			this.mc.renderGlobal.damagePartialTime = var2;
-		}
-
-	}
-
-	public float getBlockReachDistance() {
-		return 4.0F;
-	}
-
-	public void onWorldChange(World var1) {
-		super.onWorldChange(var1);
-	}
-
-	public void onUpdate() {
-		this.syncCurrentPlayItem();
-		this.prevBlockDamageMP = this.curBlockDamageMP;
-	}
-
-	private void syncCurrentPlayItem() {
-		ItemStack var1 = this.mc.thePlayer.inventory.getCurrentItem();
-		int var2 = 0;
-		if(var1 != null) {
-			var2 = var1.itemID;
-		}
-
-		if(var2 != this.currentPlayerItem) {
-			this.currentPlayerItem = var2;
-			this.netClientHandler.addToSendQueue(new Packet16BlockItemSwitch(0, this.currentPlayerItem));
-		}
-
-	}
-
-	public boolean onPlayerRightClick(EntityPlayer var1, World var2, ItemStack var3, int var4, int var5, int var6, int var7) {
-		this.syncCurrentPlayItem();
-		this.netClientHandler.addToSendQueue(new Packet15Place(var3 != null ? var3.itemID : -1, var4, var5, var6, var7));
-		return super.onPlayerRightClick(var1, var2, var3, var4, var5, var6, var7);
-	}
-
-	public EntityPlayer createPlayer(World var1) {
-		return new EntityClientPlayerMP(this.mc, var1, this.mc.session, this.netClientHandler);
-	}
+//	public void flipPlayer(EntityPlayer var1) {
+//		var1.rotationYaw = -180.0F;
+//	}
+//
+//	public boolean sendBlockRemoved(int var1, int var2, int var3, int var4) {
+//		int var5 = this.mc.theWorld.getBlockId(var1, var2, var3);
+//		boolean var6 = super.sendBlockRemoved(var1, var2, var3, var4);
+//		ItemStack var7 = this.mc.thePlayer.getCurrentEquippedItem();
+//		if(var7 != null) {
+//			var7.onDestroyBlock(var5, var1, var2, var3, this.mc.thePlayer);
+//			if(var7.stackSize == 0) {
+//				var7.func_1097_a(this.mc.thePlayer);
+//				this.mc.thePlayer.destroyCurrentEquippedItem();
+//			}
+//		}
+//
+//		return var6;
+//	}
+//
+//	public void clickBlock(int var1, int var2, int var3, int var4) {
+//		if(!this.isHittingBlock || var1 != this.currentBlockX || var2 != this.currentBlockY || var3 != this.currentBlockZ) {
+//			this.netClientHandler.addToSendQueue(new Packet14BlockDig(0, var1, var2, var3, var4));
+//			int var5 = this.mc.theWorld.getBlockId(var1, var2, var3);
+//			if(var5 > 0 && this.curBlockDamageMP == 0.0F) {
+//				Block.blocksList[var5].onBlockClicked(this.mc.theWorld, var1, var2, var3, this.mc.thePlayer);
+//			}
+//
+//			float strength = Block.blocksList[var5].blockStrength(this.mc.thePlayer);
+//			if(var5 > 0 && strength >= 1.0F) {
+//				this.sendBlockRemoved(var1, var2, var3, var4);
+//			} else {
+//				this.isHittingBlock = true;
+//				this.currentBlockX = var1;
+//				this.currentBlockY = var2;
+//				this.currentBlockZ = var3;
+//				int j = (int)(strength * 10.0F);
+//				this.mc.renderGlobal.updateBlockMiningProgress(this.mc.thePlayer.entityID, var1, var2, var3, j);
+//				this.prevBlockDamageMP = j;
+//				this.curBlockDamageMP = 0.0F;
+//				this.prevBlockDamageMP = 0.0F;
+//				this.stepSoundTickCounter = 0.0F;
+//			}
+//		}
+//
+//	}
+//
+//	public void resetBlockRemoving() {
+//		this.curBlockDamageMP = 0.0F;
+//		this.isHittingBlock = false;
+//		this.mc.renderGlobal.updateBlockMiningProgress(this.mc.thePlayer.entityID, this.currentBlockX, this.currentBlockY, this.currentBlockZ, -1);
+//	}
+//
+//	public void sendBlockRemoving(int var1, int var2, int var3, int var4) {
+//		if(this.isHittingBlock) {
+//			this.syncCurrentPlayItem();
+//			if(this.blockHitDelay > 0) {
+//				--this.blockHitDelay;
+//			} else {
+//				if(var1 == this.currentBlockX && var2 == this.currentBlockY && var3 == this.currentBlockZ) {
+//					int var5 = this.mc.theWorld.getBlockId(var1, var2, var3);
+//					if(var5 == 0) {
+//						this.isHittingBlock = false;
+//						return;
+//					}
+//
+//					Block var6 = Block.blocksList[var5];
+//					this.curBlockDamageMP += var6.blockStrength(this.mc.thePlayer);
+//					if(this.stepSoundTickCounter % 4.0F == 0.0F && var6 != null) {
+//						this.mc.sndManager.playSound(var6.stepSound.getBreakSound(), (float)var1 + 0.5F, (float)var2 + 0.5F, (float)var3 + 0.5F, (var6.stepSound.getVolume() + 1.0F) / 8.0F, var6.stepSound.getPitch() * 0.5F);
+//					}
+//
+//					++this.stepSoundTickCounter;
+//					if(this.curBlockDamageMP >= 1.0F) {
+//						this.isHittingBlock = false;
+//						this.netClientHandler.addToSendQueue(new Packet14BlockDig(2, var1, var2, var3, var4));
+//						this.sendBlockRemoved(var1, var2, var3, var4);
+//						this.curBlockDamageMP = 0.0F;
+//						this.prevBlockDamageMP = 0.0F;
+//						this.stepSoundTickCounter = 0.0F;
+//						this.blockHitDelay = 5;
+//					}
+//				} else {
+//					this.clickBlock(var1, var2, var3, var4);
+//				}
+//
+//			}
+//		}
+//	}
+//
+//	public void setPartialTime(float var1) {
+//		if(this.curBlockDamageMP <= 0.0F) {
+//			this.mc.ingameGUI.damageGuiPartialTime = 0.0F;
+//			//this.mc.renderGlobal.damagePartialTime = 0.0F;
+//            this.mc.renderGlobal.updateBlockMiningProgress(this.mc.thePlayer.entityID, this.currentBlockX, this.currentBlockY, this.currentBlockZ, -1);
+//		} else {
+//			float var2 = this.prevBlockDamageMP + (this.curBlockDamageMP - this.prevBlockDamageMP) * var1;
+//			this.mc.ingameGUI.damageGuiPartialTime = var2;
+//			//this.mc.renderGlobal.damagePartialTime = var2;
+//            this.mc.renderGlobal.updateBlockMiningProgress(this.mc.thePlayer.entityID, this.currentBlockX, this.currentBlockY, this.currentBlockZ, (int)curBlockDamageMP);
+//		}
+//
+//	}
+//
+//	public float getBlockReachDistance() {
+//		return 4.0F;
+//	}
+//
+//	public void onWorldChange(World var1) {
+//		super.onWorldChange(var1);
+//	}
+//
+//	public void onUpdate() {
+//		this.syncCurrentPlayItem();
+//		this.prevBlockDamageMP = this.curBlockDamageMP;
+//		this.mc.sndManager.playRandomMusicIfReady();
+//	}
+//
+//	private void syncCurrentPlayItem() {
+//		int var1 = this.mc.thePlayer.inventory.currentItem;
+//		if(var1 != this.currentPlayerItem) {
+//			this.currentPlayerItem = var1;
+//			this.netClientHandler.addToSendQueue(new Packet16BlockItemSwitch(this.currentPlayerItem));
+//		}
+//
+//	}
+//	
+//	public boolean sendPlaceBlock(EntityPlayer var1, World var2, ItemStack var3, int var4, int var5, int var6, int var7) {
+//		this.syncCurrentPlayItem();
+//		this.netClientHandler.addToSendQueue(new Packet15Place(var4, var5, var6, var7, var1.inventory.getCurrentItem()));
+//		boolean var8 = super.sendPlaceBlock(var1, var2, var3, var4, var5, var6, var7);
+//		return var8;
+//	}
+//
+//	public boolean sendUseItem(EntityPlayer var1, World var2, ItemStack var3) {
+//		this.syncCurrentPlayItem();
+//		this.netClientHandler.addToSendQueue(new Packet15Place(-1, -1, -1, 255, var1.inventory.getCurrentItem()));
+//		boolean var4 = super.sendUseItem(var1, var2, var3);
+//		return var4;
+//	}
+//
+//	public EntityPlayer createPlayer(World var1) {
+//		return new EntityClientPlayerMP(this.mc, var1, this.mc.session, this.netClientHandler);
+//	}
+//
+//	public void attackEntity(EntityPlayer var1, Entity var2) {
+//		this.syncCurrentPlayItem();
+//		this.netClientHandler.addToSendQueue(new Packet7UseEntity(var1.entityID, var2.entityID, 1));
+//		var1.attackTargetEntityWithCurrentItem(var2);
+//	}
+//
+//	public void interactWithEntity(EntityPlayer var1, Entity var2) {
+//		this.syncCurrentPlayItem();
+//		this.netClientHandler.addToSendQueue(new Packet7UseEntity(var1.entityID, var2.entityID, 0));
+//		var1.useCurrentItemOnEntity(var2);
+//	}
+//
+//	public ItemStack func_27174_a(int var1, int var2, int var3, boolean var4, EntityPlayer var5) {
+//		short var6 = var5.craftingInventory.func_20111_a(var5.inventory);
+//		ItemStack var7 = super.func_27174_a(var1, var2, var3, var4, var5);
+//		this.netClientHandler.addToSendQueue(new Packet102WindowClick(var1, var2, var3, var4, var7, var6));
+//		return var7;
+//	}
+//
+	public void func_20086_a(int var1, EntityPlayer var2) {
+		if(var1 != -9999) {
+		}
+	}
+	   private int targetBlockX;
+	   private int targetBlockY;
+	   private int targetBlockZ;
+	   private ItemStack miningTool = null;
+	   private float miningProgress = 0.0F;
+	   private float miningSoundTimer = 0.0F;
+	   private int miningCooldown = 0;
+	   private boolean isMiningBlock = false;
+	   private int selectedHotbarSlot = 0;
+
+	   @Override
+	   public void sendBlockRemoving(int x, int y, int z, int face) {
+		   if (this.isMiningBlock && this.isMiningBlock(x, y, z)) {
+			   return;
+		   }
+		   if (this.isMiningBlock) {
+			   this.netClientHandler.addToSendQueue(new Packet14BlockDig(1, this.targetBlockX, this.targetBlockY, this.targetBlockZ, face));
+		   }
+
+		   this.netClientHandler.addToSendQueue(new Packet14BlockDig(0, x, y, z, face));
+		   int i = this.mc.theWorld.getBlockId(x, y, z);
+		   if (i > 0 && this.miningProgress == 0.0F) {
+			   Block.blocksList[i].onBlockClicked(this.mc.theWorld, x, y, z, this.mc.thePlayer); // startMining
+		   }
+
+		   if (i > 0 && Block.blocksList[i].blockStrength(this.mc.thePlayer) >= 1.0F) {
+			   this.sendBlockRemoved(x, y, z, face);
+		   } else {
+			   this.isMiningBlock = true;
+			   this.targetBlockX = x;
+			   this.targetBlockY = y;
+			   this.targetBlockZ = z;
+			   this.miningTool = this.mc.thePlayer.getCurrentEquippedItem();
+			   this.miningProgress = 0.0F;
+			   this.miningSoundTimer = 0.0F;
+			   this.mc
+			   .renderGlobal
+			   .updateBlockMiningProgress(
+					   this.mc.thePlayer.entityID, this.targetBlockX, this.targetBlockY, this.targetBlockZ, (int)(this.miningProgress * 10.0F) - 1
+					   );
+		   }
+	   }
+
+	   @Override
+	   public boolean sendBlockRemoved(int x, int y, int z, int face) {
+		   Block block = Block.blocksList[this.mc.theWorld.getBlockId(x, y, z)];
+		   if (block == null) {
+			   return false;
+		   } else {
+			   //this.mc.sndManager.playSound(block.stepSound.getBreakSound(), (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, (block.stepSound.getVolume() + 1.0F) / 8.0F, block.stepSound.getPitch() * 0.5F);
+			   //this.mc.theWorld.doEvent(2001, x, y, z, block.blockID + (this.mc.theWorld.getBlockMetadata(x, y, z) << 12));
+			   // TODO: investigate block disintegrating particles
+			   this.mc.effectRenderer.addBlockDestroyEffects(x, y, z);
+			   int i = this.mc.theWorld.getBlockMetadata(x, y, z);
+			   boolean j = this.mc.theWorld.setBlockWithNotify(x, y, z, 0);
+			   if (j) {
+				   this.mc.sndManager.playSound(block.stepSound.getBreakSound(), (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, (block.stepSound.getVolume() + 1.0F) / 2.0F, block.stepSound.getPitch() * 0.8F);
+				   block.onBlockDestroyedByPlayer(this.mc.theWorld, x, y, z, i); // onBroken
+			   }
+
+			   this.targetBlockY = -1;
+			   ItemStack itemStack = this.mc.thePlayer.getCurrentEquippedItem();
+			   if (itemStack != null) {
+				   itemStack.onDestroyBlock(block.blockID, x, y, z, this.mc.thePlayer);
+				   if (itemStack.stackSize == 0) {
+					   this.mc.thePlayer.destroyCurrentEquippedItem();
+				   }
+			   }
+
+			   return (boolean)j;
+		   }
+	   }
+
+	   @Override
+	   public void resetBlockRemoving() {
+	      if (this.isMiningBlock) {
+	         this.netClientHandler.addToSendQueue(new Packet14BlockDig(1, this.targetBlockX, this.targetBlockY, this.targetBlockZ, -1));
+	      }
+
+	      this.isMiningBlock = false;
+	      this.miningProgress = 0.0F;
+	      this.mc.renderGlobal.updateBlockMiningProgress(this.mc.thePlayer.entityID, this.targetBlockX, this.targetBlockY, this.targetBlockZ, -1);
+	   }
+
+	   @Override
+	   public void clickBlock(int x, int y, int z, int face) {
+	      this.updateSelectedHotbarSlot();
+	      if (this.miningCooldown > 0) {
+	         this.miningCooldown--;
+	      } else {
+	         if (this.isMiningBlock(x, y, z)) {
+	            int i = this.mc.theWorld.getBlockId(x, y, z);
+	            if (i == 0) {
+	               this.isMiningBlock = false;
+	               return;
+	            }
+
+	            Block block = Block.blocksList[i];
+	            this.miningProgress = this.miningProgress + block.blockStrength(this.mc.thePlayer);
+	            if (this.miningSoundTimer % 4.0F == 0.0F && block != null) {
+	               this.mc
+	                  .sndManager
+	                  .playSound(block.stepSound.getStepSound(), x + 0.5F, y + 0.5F, z + 0.5F, (block.stepSound.getVolume() + 1.0F) / 8.0F, block.stepSound.getPitch() * 0.5F);
+	            }
+
+	            this.miningSoundTimer++;
+	            if (this.miningProgress >= 1.0F) {
+	               this.isMiningBlock = false;
+	               this.netClientHandler.addToSendQueue(new Packet14BlockDig(2, x, y, z, face));
+	               this.sendBlockRemoved(x, y, z, face);
+	               this.miningProgress = 0.0F;
+	               this.miningSoundTimer = 0.0F;
+	               this.miningCooldown = 5;
+	            }
+
+	            this.mc
+	               .renderGlobal
+	               .updateBlockMiningProgress(
+	                  this.mc.thePlayer.entityID, this.targetBlockX, this.targetBlockY, this.targetBlockZ, (int)(this.miningProgress * 10.0F) - 1
+	               );
+	         } else {
+	            this.sendBlockRemoving(x, y, z, face);
+	         }
+	      }
+	   }
+
+	   @Override
+	   public float getBlockReachDistance() {
+	      return 4.0F;
+	   }
+
+	   @Override
+	   public void onUpdate() {
+	      this.updateSelectedHotbarSlot();
+	      this.mc.sndManager.playRandomMusicIfReady();
+	   }
+
+	   private boolean isMiningBlock(int x, int y, int z) {
+	      ItemStack itemStack = this.mc.thePlayer.getCurrentEquippedItem();
+	      int i = this.miningTool == null && itemStack == null ? 1 : 0;
+	      if (this.miningTool != null && itemStack != null) {
+	         i = itemStack.itemID != this.miningTool.itemID
+	               || !itemStack.isItemStackDamageable() && itemStack.getItemDamage() != this.miningTool.getItemDamage()
+	            ? 0
+	            : 1;
+	      }
+
+	      return x == this.targetBlockX && y == this.targetBlockY && z == this.targetBlockZ && i != 0;
+	   }
+
+	   private void updateSelectedHotbarSlot() {
+	      int i = this.mc.thePlayer.inventory.currentItem;
+	      if (i != this.selectedHotbarSlot) {
+	         this.selectedHotbarSlot = i;
+	         this.netClientHandler.addToSendQueue(new Packet16BlockItemSwitch(this.selectedHotbarSlot));
+	      }
+	   }
+
+	   @Override
+	   public boolean sendPlaceBlock(EntityPlayer player, World world, ItemStack item, int x, int y, int z, int face) {
+	      this.updateSelectedHotbarSlot();
+	      int i = 0;
+	      int j = world.getBlockId(x, y, z);
+	      if (j > 0 && Block.blocksList[j].blockActivated(world, x, y, z, player)) { // use
+	    	  i = 1;
+	      }
+
+	      if (i == 0 && item != null && item.getItem() instanceof ItemBlock) {
+	    	  ItemBlock blockItem = (ItemBlock)item.getItem();
+	         if (!blockItem.onPlace(item, player, world, x, y, z, face)) {
+	            return false;
+	         }
+	      }
+
+	      this.netClientHandler.addToSendQueue(new Packet15Place(x, y, z, face, player.inventory.getCurrentItem()));
+	      if (i != 0) {
+	         return true;
+	      } else if (item == null) {
+	         return false;
+	      } else {
+	         return item.useItem(player, world, x, y, z, face); // useOn
+	      }
+	   }
+
+	   @Override
+	   public boolean sendUseItem(EntityPlayer player, World world, ItemStack itemInHand) {
+	      this.updateSelectedHotbarSlot();
+	      this.netClientHandler.addToSendQueue(new Packet15Place(-1, -1, -1, 255, player.inventory.getCurrentItem()));
+	      int i = itemInHand.stackSize;
+	      ItemStack itemStack = itemInHand.useItemRightClick(world, player);
+	      if (itemStack != itemInHand || itemStack != null && itemStack.stackSize != i) {
+	         player.inventory.mainInventory[player.inventory.currentItem] = itemStack;
+	         if (itemStack.stackSize == 0) {
+	            player.inventory.mainInventory[player.inventory.currentItem] = null;
+	         }
+
+	         return true;
+	      } else {
+	         return false;
+	      }
+	   }
+
+	   @Override
+	   public EntityPlayer createPlayer(World var1) {
+			return new EntityClientPlayerMP(this.mc, var1, this.mc.session, this.netClientHandler);
+		}
+
+	   @Override
+	   public void attackEntity(EntityPlayer player, Entity target) {
+	      this.updateSelectedHotbarSlot();
+	      this.netClientHandler.addToSendQueue(new Packet7UseEntity(player.entityID, target.entityID, 1));
+	      player.attackTargetEntityWithCurrentItem(target);
+	   }
+
+	   @Override
+	   public void interactWithEntity(EntityPlayer player, Entity target) {
+	      this.updateSelectedHotbarSlot();
+	      this.netClientHandler.addToSendQueue(new Packet7UseEntity(player.entityID, target.entityID, 0));
+	      player.useCurrentItemOnEntity(target);
+	   }
+
+	   @Override
+	   public ItemStack func_27174_a(int syncId, int slotId, int clickData, boolean actionType, EntityPlayer player) {
+	      int i = player.craftingInventory.func_20111_a(player.inventory);
+	      ItemStack itemStack = super.func_27174_a(syncId, slotId, clickData, actionType, player);
+	      this.netClientHandler.addToSendQueue(new Packet102WindowClick(syncId, slotId, clickData, actionType, itemStack, (short)i));
+	      return itemStack;
+	   }
+
+	   public void stopUsingHand(EntityPlayer player) {
+	      this.updateSelectedHotbarSlot();
+	      this.netClientHandler.addToSendQueue(new Packet14BlockDig(5, 0, 0, 0, 255));
+	      //player.stopUsingItem();
+	   }
 }
--- net/minecraft/src/SlotArmor.java
+++ net/minecraft/src/SlotArmor.java
@@ -1,13 +1,17 @@
 package net.minecraft.src;
 
-class SlotArmor extends SlotInventory {
+class SlotArmor extends Slot {
 	final int armorType;
-	final GuiInventory guiInventory;
-
-	SlotArmor(GuiInventory var1, GuiContainer var2, IInventory var3, int var4, int var5, int var6, int var7) {
-		super(var2, var3, var4, var5, var6);
-		this.guiInventory = var1;
-		this.armorType = var7;
+	final ContainerPlayer inventory;
+
+	SlotArmor(ContainerPlayer var1, IInventory var2, int var3, int var4, int var5, int var6) {
+		super(var2, var3, var4, var5);
+		this.inventory = var1;
+		this.armorType = var6;
+	}
+
+	public int getSlotStackLimit() {
+		return 1;
 	}
 
 	public boolean isItemValid(ItemStack var1) {
--- net/minecraft/src/EntityClientPlayerMP.java
+++ net/minecraft/src/EntityClientPlayerMP.java
@@ -3,7 +3,7 @@
 import net.minecraft.client.Minecraft;
 
 public class EntityClientPlayerMP extends EntityPlayerSP {
-	private NetClientHandler sendQueue;
+	public NetClientHandler sendQueue;
 	private int motionUpdateCounter = 0;
 	private double oldPosX;
 	private double oldBasePos;
@@ -11,33 +11,47 @@
 	private double oldPosZ;
 	private float oldRotationYaw;
 	private float oldRotationPitch;
-	private InventoryPlayer serverSideInventory = new InventoryPlayer((EntityPlayer)null);
+	private boolean field_9382_bF = false;
+	private boolean wasSneaking = false;
+	private int field_12242_bI = 0;
 
 	public EntityClientPlayerMP(Minecraft var1, World var2, Session var3, NetClientHandler var4) {
 		super(var1, var2, var3);
 		this.sendQueue = var4;
 	}
+	
+	public boolean attackEntityFrom(Entity var1, int var2) {
+		return false;
+	}
+
+	public void heal(int var1) {
+	}
 
 	public void onUpdate() {
-		super.onUpdate();
-		this.sendMotionUpdates();
-	}
-
-	public void onPlayerUpdate() {
-		this.sendMotionUpdates();
+		if(this.worldObj.blockExists(MathHelper.floor_double(this.posX), 64, MathHelper.floor_double(this.posZ))) {
+			super.onUpdate();
+			this.sendMotionUpdates();
+		}
+		
 	}
 
 	public void sendMotionUpdates() {
 		if(this.motionUpdateCounter++ == 20) {
-			if(!this.inventory.getInventoryEqual(this.serverSideInventory)) {
-				this.sendQueue.addToSendQueue(new Packet5PlayerInventory(-1, this.inventory.mainInventory));
-				this.sendQueue.addToSendQueue(new Packet5PlayerInventory(-2, this.inventory.craftingInventory));
-				this.sendQueue.addToSendQueue(new Packet5PlayerInventory(-3, this.inventory.armorInventory));
-				this.serverSideInventory = this.inventory.copyInventory();
-			}
+			this.sendInventoryChanged();
 
 			this.motionUpdateCounter = 0;
 		}
+		
+		boolean sneak = this.isSneaking();
+		if(sneak != this.wasSneaking) {
+			if(sneak) {
+				this.sendQueue.addToSendQueue(new Packet19EntityAction(this, 1));
+			} else {
+				this.sendQueue.addToSendQueue(new Packet19EntityAction(this, 2));
+			}
+
+			this.wasSneaking = sneak;
+		}
 
 		double var1 = this.posX - this.oldPosX;
 		double var3 = this.boundingBox.minY - this.oldBasePos;
@@ -47,16 +61,33 @@
 		double var11 = (double)(this.rotationPitch - this.oldRotationPitch);
 		boolean var13 = var3 != 0.0D || var5 != 0.0D || var1 != 0.0D || var7 != 0.0D;
 		boolean var14 = var9 != 0.0D || var11 != 0.0D;
-		if(var13 && var14) {
+		if(this.ridingEntity != null) {
+			if(var14) {
+				this.sendQueue.addToSendQueue(new Packet11PlayerPosition(this.motionX, -999.0D, -999.0D, this.motionZ, this.onGround));
+			} else {
+				this.sendQueue.addToSendQueue(new Packet13PlayerLookMove(this.motionX, -999.0D, -999.0D, this.motionZ, this.rotationYaw, this.rotationPitch, this.onGround));
+			}
+
+			var13 = false;
+		} else if(var13 && var14) {
 			this.sendQueue.addToSendQueue(new Packet13PlayerLookMove(this.posX, this.boundingBox.minY, this.posY, this.posZ, this.rotationYaw, this.rotationPitch, this.onGround));
+			this.field_12242_bI = 0;
 		} else if(var13) {
 			this.sendQueue.addToSendQueue(new Packet11PlayerPosition(this.posX, this.boundingBox.minY, this.posY, this.posZ, this.onGround));
+			this.field_12242_bI = 0;
 		} else if(var14) {
 			this.sendQueue.addToSendQueue(new Packet12PlayerLook(this.rotationYaw, this.rotationPitch, this.onGround));
+			this.field_12242_bI = 0;
 		} else {
 			this.sendQueue.addToSendQueue(new Packet10Flying(this.onGround));
+			if(this.field_9382_bF == this.onGround && this.field_12242_bI <= 200) {
+				++this.field_12242_bI;
+			} else {
+				this.field_12242_bI = 0;
+			}
 		}
 
+		this.field_9382_bF = this.onGround;
 		if(var13) {
 			this.oldPosX = this.posX;
 			this.oldBasePos = this.boundingBox.minY;
@@ -71,24 +102,35 @@
 
 	}
 
-	protected void joinEntityItemWithWorld(EntityItem var1) {
-		System.out.println("Dropping?");
-		Packet21PickupSpawn var2 = new Packet21PickupSpawn(var1);
-		this.sendQueue.addToSendQueue(var2);
-		var1.posX = (double)var2.xPosition / 32.0D;
-		var1.posY = (double)var2.yPosition / 32.0D;
-		var1.posZ = (double)var2.zPosition / 32.0D;
-		var1.motionX = (double)var2.rotation / 128.0D;
-		var1.motionY = (double)var2.pitch / 128.0D;
-		var1.motionZ = (double)var2.roll / 128.0D;
-	}
-
 	public void sendChatMessage(String var1) {
 		this.sendQueue.addToSendQueue(new Packet3Chat(var1));
 	}
 
 	public void swingItem() {
 		super.swingItem();
-		this.sendQueue.addToSendQueue(new Packet18ArmAnimation(this, 1));
+		this.sendQueue.addToSendQueue(new Packet18Animation(this, 1));
+	}
+	
+	protected void damageEntity(int var1) {
+		this.health -= var1;
+	}
+	
+	public void respawnPlayer() {
+		this.sendInventoryChanged();
+		this.sendQueue.addToSendQueue(new Packet9Respawn((byte)0));
+	}
+	
+	@Override
+	public void dropCurrentItem() {
+		this.sendQueue.addToSendQueue(new Packet14BlockDig(4, 0, 0, 0, 0));
+	}
+
+	private void sendInventoryChanged() {
+	}
+	
+	public void closeScreen() {
+		this.sendQueue.addToSendQueue(new Packet101CloseWindow(this.craftingInventory.windowId));
+		this.inventory.setItemStack((ItemStack)null);
+		super.closeScreen();
 	}
 }
--- /dev/null
+++ net/minecraft/src/Packet28EntityVelocity.java
@@ -1,0 +1,73 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet28EntityVelocity extends Packet {
+	public int entityId;
+	public int motionX;
+	public int motionY;
+	public int motionZ;
+
+	public Packet28EntityVelocity() {
+	}
+
+	public Packet28EntityVelocity(Entity var1) {
+		this(var1.entityID, var1.motionX, var1.motionY, var1.motionZ);
+	}
+
+	public Packet28EntityVelocity(int var1, double var2, double var4, double var6) {
+		this.entityId = var1;
+		double var8 = 3.9D;
+		if(var2 < -var8) {
+			var2 = -var8;
+		}
+
+		if(var4 < -var8) {
+			var4 = -var8;
+		}
+
+		if(var6 < -var8) {
+			var6 = -var8;
+		}
+
+		if(var2 > var8) {
+			var2 = var8;
+		}
+
+		if(var4 > var8) {
+			var4 = var8;
+		}
+
+		if(var6 > var8) {
+			var6 = var8;
+		}
+
+		this.motionX = (int)(var2 * 8000.0D);
+		this.motionY = (int)(var4 * 8000.0D);
+		this.motionZ = (int)(var6 * 8000.0D);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.entityId = var1.readInt();
+		this.motionX = var1.readShort();
+		this.motionY = var1.readShort();
+		this.motionZ = var1.readShort();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.entityId);
+		var1.writeShort(this.motionX);
+		var1.writeShort(this.motionY);
+		var1.writeShort(this.motionZ);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_6498_a(this);
+	}
+
+	public int getPacketSize() {
+		return 10;
+	}
+}
